<?php
namespace LMS\Tools\Coursebuilder\Repositories;

use LMS\Libraries\Base;
use LMS\Tools\Coursebuilder\Tables;

class Extensions extends Base\Repository
{
	public function __construct($options = array())
	{
		parent::__construct($options);
		$this->table = new Tables\Extensions($this->db);
	}

	public function getExtensionByElement($element, $type = 'module', $clientId = 0)
	{
		return $this->getByFilter(
			array(
				'element' => $element,
				'type' => $type,
				'client_id' => $clientId,
				'resultType' => 'object'
			)
		);
	}

	protected function prepareFilter($query, &$filterOptions)
	{
		$alias = $this->table->getTableAlias();

		$conditions = array();

		if(isset($filterOptions['id']) && $filterOptions['id']){
			$conditions[] = $alias.".".$this->table->getKeyName()." = ".$this->db->quote($filterOptions['id']);
		}

		if(isset($filterOptions['type']) && $filterOptions['type']){
			$conditions[] = $alias.".type = ".$this->db->quote($filterOptions['type']);
		}

		if(isset($filterOptions['client_id'])){
			$conditions[] = $alias.".client_id = ".$this->db->quote($filterOptions['client_id']);
		}

		if(isset($filterOptions['enabled'])){
			$conditions[] = $alias.".enabled = ".$this->db->quote($filterOptions['enabled']);
		}

		if(isset($filterOptions['element']) && $filterOptions['element']){
			$conditions[] = $alias.".element = ".$this->db->quote($filterOptions['element']);
		}

		$query->where($conditions);

		return parent::prepareFilter($query, $filterOptions);
	}
}