<?php
namespace LMS\Tools\Homework\Controllers;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Homeworks extends Base\Controller
{
	public function __construct($config=array())
	{
		parent::__construct($config);

		$this->registerTask('unpublish', 'publish');
	}
	
	public function show()
	{
		$Itemid = $this->input->get('Itemid', 0);
		$courseId = $this->input->get('course_id', 0);
		$userId = $this->user->get('id');

		$modelHomeworks = $this->getModel('Homeworks');
		$modelHomeworks->setState('courseId', $courseId);
		$this->populateModel($modelHomeworks);

		$view = $this->getView('Homeworks');
		if($Itemid){
			$view->Itemid = $Itemid;
		}
		
		$view->setModel($modelHomeworks, true);

		if($this->acl->CheckPermissions('homework', 'manage')){
			$view->showItemsForTeacher();
		} else
		if($this->acl->CheckPermissions('homework', 'view')){
			$modelHomeworks->setState('published', 1);
			$modelHomeworks->setState('userId', $userId);

			$view->showItemsForLearner();
		}
	}

	public function publish()
	{
		$course_id = $this->input->get('course_id', 0);
		$cid = $this->input->get('cid', array(), 'array');
		$data = array('publish' => 1, 'unpublish' => 0);
		$task = $this->getTask();
		$value = \JArrayHelper::getValue($data, $task, 0, 'int');

		$modelHomeworks = $this->getModel('Homeworks');
		$modelHomeworks->setState('homework.course_id', $course_id);

		\JArrayHelper::toInteger($cid);

		if($this->acl->CheckPermissions('homework', 'manage')){
			$modelHomeworks->publish($cid, $value);
		}

		$link = 'index.php?option=com_joomla_lms';
		$link .= '&task=homework.homeworks.show';
		$link .= '&course_id='.$course_id;
		$link .= '&Itemid='.$this->input->get('Itemid');

		$link = \JRoute::_($link);

		$this->setRedirect(html_entity_decode($link));
	}

	public function saveOrderAjax()
	{
		$pks = $this->input->post->get('cid', array(), 'array');
		$order = $this->input->post->get('order', array(), 'array');

		\JArrayHelper::toInteger($pks);
		\JArrayHelper::toInteger($order);

		$modelHomeworks = $this->getModel('Homeworks');

		if($this->acl->CheckPermissions('homework', 'manage')){
			$return = $modelHomeworks->saveorder($pks, $order);
		}

		if ($return)
		{
			echo "1";
		}

		$this->application->close();
	}
}