<?php
namespace LMS\Tools\Homework\View;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Results extends Base\View
{
	protected $extension = 'com_joomla_lms';
	protected $viewName = 'Results';

	public function __construct($config=array())
	{
		$this->viewDir = __DIR__;
		parent::__construct($config);
	}

	public function display($tpl = null)
	{
		return parent::display($tpl);
	}

	public function show()
	{
		$resultsModel = $this->getModel('Results');
		$homeworkModel = $this->getModel('Homework');

		$this->homeworkItem = $homeworkModel->getItem();
		$this->items = $resultsModel->getItems();
		$this->pagination = $resultsModel->getPagination();
		$this->state = $resultsModel->getState();
		$this->toolbar = $this->getToolbar();

		$this->filters = $this->getFilters();

		$this->display();
	}

	public function getToolbar()
	{
		$toolbar = new \LMS\Widgets\ContentToolbar();
		$toolbar->addBackButton( array('href'=>'javascript: Joomla.submitbutton(\'homework.results.cancel\')') );

		return $toolbar;
	}

	public function getFilters()
	{
		$resultsModel = $this->getModel('Results');
		$filtersForm = $resultsModel->getForm('results_filters', array('control'=>'filter'));

		$filters = new \LMS\Widgets\Filters();
		//left
		$filters->addFilter($filtersForm->getField('status'));
		$filters->addFilter($filtersForm->getField('group_id'));
		$filters->addFilter($filtersForm->getField('user_id'));

		//right
		$filters->addFilter($this->pagination->getLimitBox());

		return $filters;
	}
}