<?php
defined('JPATH_PLATFORM') or die;

use LMS\Libraries;

class JFormFieldStudentGroupExt extends JFormField
{	
	protected $type = 'StudentGroupExt';
	
	protected function getInput()
	{		
		Libraries\ServiceLocator::load('tool.users');
		
		$rep	= Libraries\ServiceLocator::get('group_rep');		
		$items = $rep->getByFilter(array(
				'fields'=>'group.name, group.id',
				'numberStudentsInGroup'=>true
		));
		
		$html = array();
		$attr = '';
		
		$hint = JText::_($this->hint);
		
		$attr .= !empty($this->class) ? ' class="' . $this->class . '"' : '';
		$attr .= !empty($this->size) ? ' size="' . $this->size . '"' : '';
		$attr .= $this->multiple ? ' multiple' : '';		
		$attr .= !empty($this->hint) ? ' data-placeholder="' . $hint . '"' : '';
		$attr .= $this->required ? ' required aria-required="true"' : '';
		$attr .= $this->autofocus ? ' autofocus' : '';

		if ((string) $this->readonly == '1' || (string) $this->readonly == 'true' || (string) $this->disabled == '1'|| (string) $this->disabled == 'true')
		{
			$attr .= ' disabled="disabled"';
		}

		$attr .= $this->onchange ? ' onchange="' . $this->onchange . '"' : '';		

		$options = array();
		$options[] = '<option data-students_count="0" value="0"></option>';
		
		foreach($items AS $item) {		
			$options[] = '<option value="'.$item->id.'">'.$item->name.'</option>';
		}	
		
		$html = '';		
		$html .= '<select id="' . $this->id . '" name="' . $this->name . '"' . $attr . '>';
		$html .= implode("\n", $options);
		$html .= '</select>';

		return $html;		
	}
}
?>